
#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#ifdef MBUSTCPLIB_EXPORTS
    #define MODBUSTCP_DLL __declspec ( dllexport )
#else
    #define MODBUSTCP_DLL __declspec ( dllimport )
#endif



#include <string.h>
#include <iostream>
#include <winsock2.h>


class MODBUSTCP_DLL TCPModbusIntf
{
public:
    static TCPModbusIntf* GetInstance(void);

    TCPModbusIntf();
	virtual ~TCPModbusIntf();

    virtual BOOL Initialize(const WORD wId, const std::string szLocalIpAddr, const WORD wLocalPort, const std::string szServerIpAddr);
    virtual void Close();
    virtual LPCSTR LastErrorString(void);

    // Modbus Functions
    virtual BOOL WriteSingleHoldReg(WORD wRegAddr, WORD& wData);               // Write single Holding Register
    virtual BOOL WriteMultiHoldRegs(WORD wRegAddr, WORD* wData, WORD wCount);  // Write multiple Holding Registers
    virtual BOOL ReadHoldRegs(WORD wRegAddr, WORD* wData, WORD wCount);        // Read Holding Registers
    virtual BOOL ReadInputRegs(WORD wRegAddr, WORD* wData, WORD wCount);       // Read Input Registers
};

